---
permalink: /docs/standard-library
layout: single
classes: wide
title: Standard Library
sidebar:
  nav: "sidebar"
---

<!-- This page is auto-generated. To edit it, you'll need to change the filter_fetch.py -->

The Standard Library is a special set of filters, approved or written by the Regolith maintainers. Standard Filters offers the safest, easiest, and best support. 

Please be aware that when running in safe mode, standard filters are the only filters allowed.

## Standard Filters

| Filter | Description |
| ------ | ----------- |
| [blockbench_convert](https://github.com/Bedrock-OSS/regolith-filters/tree/master/blockbench_convert) | Converts blockbench models into `.geometry.json` files. |
| [bump_manifest](https://github.com/Bedrock-OSS/regolith-filters/tree/master/bump_manifest) | Bumps the manifest version in your RP and BP. Good for multiplayer testing where you need to avoid pack-caching issues. |
| [filter_tester](https://github.com/Bedrock-OSS/regolith-filters/tree/master/filter_tester) | Meant to be used by the filter developers to test other filters. It compares the expected results with the files generated by Regolith. |
| [fix_emissive](https://github.com/Bedrock-OSS/regolith-filters/tree/master/fix_emissive) | Fixes emissive issues in your textures, by removing the color data from fully transparent pixels. |
| [gametests](https://github.com/Bedrock-OSS/regolith-filters/tree/master/gametests) | Compiles gametests into pack. |
| [json_cleaner](https://github.com/Bedrock-OSS/regolith-filters/tree/master/json_cleaner) | Removes comments from all json files in the project. Useful, since some filters cannot understand files with comments. |
| [name_ninja](https://github.com/Bedrock-OSS/regolith-filters/tree/master/name_ninja) | Automatically generates entity, block, spawn egg, and item names, based on a custom 'name' field, or on the entities identifier. |
| [texture_convert](https://github.com/Bedrock-OSS/regolith-filters/tree/master/texture_convert) | Converts popular image editor file formats, such as .psd to .png. |
| [texture_list](https://github.com/Bedrock-OSS/regolith-filters/tree/master/texture_list) | Automatically creates the `texture_list.json` file, based on the images you've added into your resource pack. |

The full, up to date list of filters can be found on our github. We are looking into maintaining a list here, but for now please visit our github. 

## Using a Standard Filter

You may install standard filters by name. For example: `regolith install name_ninja`.

The syntax for standard filters usage is like this:

```json
{
  "filter": "<filter_name>",
  "settings" { ... } // Optional
}
```
